/*-----------------------------------------------------------------------------

  SpinParser.h
  SpinParserLib
  By Dave Fletcher
  (c) 2008 All Rights Reserved

  This code is released under the terms of the GNU Lesser General Public
  License (LGPL). See COPYING.

  INDUSTRIAL APPLICATION WARNING:
  Please note, this software is EXPERIMENTAL and is likely to remain in this
  state for a good while. Please do not use this software in mission critical
  applications and in situations where the safety of human-beings is at stake.

  This document is non-normative. It is not compared with the original Parallax
  documents or any Parallax source codes. It is derived mainly from the user
  manual and tests run inside the Propeller Tool.

  If you find bugs, the current place to report them is in the Parallax user
  forums. This may change in future:

    http://forums.parallax.com/forums/?f=25&m=253050&g=253340

-----------------------------------------------------------------------------*/

#ifndef SPIN_PARSER
#define SPIN_PARSER

#ifdef _MSC_VER
	#define DLLEXPORT __declspec(dllexport)
#else
	#define DLLEXPORT
#endif

#include <list>
#include <stack>
#include <string>
#include <iostream>
#include <Tree.h>
#include "libSpinParser_la-spinparse.h"

namespace SpinParser {

class ParserContext {
  public:
    ParserContext(void);
	~ParserContext(void);
    int popall_return_value;
	bool push_next;
    std::stack<size_t> indent_stack;
	std::list<std::string> locals;
	std::list<std::string> params;
	std::list<std::string> variables;
	std::list<std::string> datvariables;
	std::list<std::string> constants;
	Pointer<Tree> getTree(void);
};

class SpinParser {

  public:
    ParserContext the_parser_context;

    DLLEXPORT SpinParser(void);
	DLLEXPORT ~SpinParser(void);
	DLLEXPORT void parse(void);
	DLLEXPORT void reset(void);
	Pointer<Tree> getTree(void);
};

}

#endif /* [SPIN_PARSER] */
