/*-----------------------------------------------------------------------------

  Tree.cpp
  SpinParserLib
  By Dave Fletcher
  (c) 2008 All Rights Reserved

  This code is released under the terms of the GNU Lesser General Public
  License (LGPL). See COPYING.

  INDUSTRIAL APPLICATION WARNING:
  Please note, this software is EXPERIMENTAL and is likely to remain in this
  state for a good while. Please do not use this software in mission critical
  applications and in situations where the safety of human-beings is at stake.

  This document is non-normative. It is not compared with the original Parallax
  documents or any Parallax source codes. It is derived mainly from the user
  manual and tests run inside the Propeller Tool.

  If you find bugs, the current place to report them is in the Parallax user
  forums. This may change in future:

    http://forums.parallax.com/forums/?f=25&m=253050&g=253340

-----------------------------------------------------------------------------*/

#include "Tree.h"

namespace SpinParser {

  Tree::ObjectList Tree::getObjects(StringPointer name) {
    Tree::ObjectList l;
    ObjectMapIterator i = children.find(name);
    if (i != children.end()) {
      l = children[name];
    }
    return l;
  }

  Node::NodePointer Tree::getTopObject(void) {
    ObjectList l = getObjects(newStringPointer("<<top>>"));
    return l.front();
  }

  StringList &Tree::getObjectNames(void) {
    return objectnames;
  }

  void Tree::addObject(StringPointer name, Node::NodePointer root) {
    ObjectMapIterator i = children.find(name);
    if (i == children.end()) {
      Node::NodeList l;
      l.push_back(root);
      children[name] = l;
      objectnames.push_back(name);
    }
    else {
      i->second.push_back(root);
    }
  }

}
